---
- name: Converge
  hosts: secondary_dcs
  gather_facts: false
  pre_tasks:
    - set_fact:
        ansible_cust_password_file: "{{ molecule_ephemeral_directory }}/{{ inventory_hostname }}_updated_password.txt"
        ansible_cust_host_file: "{{ molecule_ephemeral_directory }}/{{ inventory_hostname }}_updated_host.txt"
        ansible_cust_user_file: "{{ molecule_ephemeral_directory }}/{{ inventory_hostname }}_updated_user.txt"
    - set_fact:
        ansible_password_tmp: "{{ lookup('file', ansible_cust_password_file, errors='ignore') }}"
        ansible_host_tmp: "{{ lookup('file', ansible_cust_host_file, errors='ignore') }}"
        ansible_user_tmp: "{{ lookup('file', ansible_cust_user_file, errors='ignore') }}"
    - set_fact:
        ansible_password: "{{ ansible_password_tmp }}"
      when: (ansible_password_tmp | length) > 0
    - set_fact:
        ansible_host: "{{ ansible_host_tmp }}"
      when: (ansible_host_tmp | length) > 0
    - set_fact:
        ansible_user: "{{ ansible_user_tmp }}"
      when: (ansible_user_tmp | length) > 0
    - debug:
        var: ansible_password
    - debug:
        var: ansible_host
    - debug:
        var: ansible_user
    - name: Gather facts
      setup:
    - set_fact:
        ipv4_addresses_tmp: "[{% for x in ansible_ip_addresses %}{{ x + ',' if (x | ansible.netcommon.ipv4) }}{% endfor %}]"
        ip_dns_servers_tmp: "{{ groups['secondary_dcs'] | map('extract', hostvars, ['ansible_ip_addresses']) }}"
    - set_fact:
        ipv4_addresses: "{{ ipv4_addresses_tmp | from_yaml }}"
        ip_dns_servers: "{{ [hostvars[groups['primary_dc'][0]]['ansible_host']] + (ip_dns_servers_tmp | from_yaml | flatten(levels=1)) }}"
    - debug:
        msg: "{{ ip_dns_servers }}"
  tasks:
    - block:
        - name: "Include ansible_role_new_domain"
          include_role:
            name: "ansible_role_new_domain"
          vars:
            new_domain_domainadmin_password: P@ssw0rd!
            new_domain_localadmin_password: P@ssw0rd!
            new_domain_domain_safe_mode_password: P@ssw0rd!
            new_domain_static_ips: "{{ ipv4_addresses }}"
            new_domain_gws: "{{ ansible_interfaces | selectattr('default_gateway', 'defined') | map(attribute='default_gateway') }}"
            new_domain_dns_ips:
              - "{{ ip_dns_servers }}"
            new_domain_domain: rh3sge1.net
            new_domain_netbios: RH3SGE1
            new_domain_pdc: "{{ pdc | default(True) }}"
      always:
        - name: Dump updated_password.txt
          copy:
            content: "{{ ansible_password }}"
            dest: "{{ ansible_cust_password_file }}"
          delegate_to: localhost

        - name: Dump updated_host.txt
          copy:
            content: "{{ ansible_host }}"
            dest: "{{ ansible_cust_host_file }}"
          delegate_to: localhost

        - name: Dump updated_user.txt
          copy:
            content: "{{ ansible_user }}"
            dest: "{{ ansible_cust_user_file }}"
          delegate_to: localhost
